// C/C++
#include        <iostream>
#include        <iomanip>
#include	<vector>
#include	<string>
#include	<list>
#include        <stdio.h>
#include        <stdlib.h>
#include        <unistd.h>
#include        <math.h>

// gtk/gdk/glade
#include        <glib.h>		// useful g_ functions (gerror, etc.)
#include        <gtk/gtk.h>
#include        <gtkgl/gtkglarea.h>
#include        <glade/glade.h>
#include        <gdk/gdkkeysyms.h>

// gl
#include        <GL/gl.h>
#include        <GL/glu.h>

using namespace std;

#include	"mgr.h"

// prototypes
void	parseCmdLine(int argc,char **argv);
int	main(int argc, char **argv);

void parseCmdLine(int argc,char **argv)
{
        int     ch;
        int     opterr=0;
        char    *progname, *ptr;
        char    *usage =
		"usage: %s < srcfile.obj > destfile.obj                    \n"
                "options:\n"
                "\t -h          \t this help message                       \n"
                ;

  /* get basename of argv */
  if((ptr = strrchr(*argv,'/')) != NULL)        progname = ++ptr;
  else                                          progname = *argv;

  while((ch = getopt(argc,argv,"h"))!=EOF) {
    switch(ch) {
      case 'h':
      default:
        opterr = 1;
        break;
    }
  }

  if(opterr) {
    fprintf(stderr,usage,progname);
    exit(1);
  }
}


void set_widget_data(GladeXML* xml, Mgr* mgr)
{
	GtkWidget*	w;

  w = glade_xml_get_widget(xml,"main");
  gtk_object_set_data(GTK_OBJECT(w),"mgr",mgr);

  w = glade_xml_get_widget(xml,"obj_open");
  gtk_object_set_data(GTK_OBJECT(w),"mgr",mgr);

  w = glade_xml_get_widget(xml,"obj_clear");
  gtk_object_set_data(GTK_OBJECT(w),"mgr",mgr);

  w = glade_xml_get_widget(xml,"display_wire");
  gtk_object_set_data(GTK_OBJECT(w),"mgr",mgr);

  w = glade_xml_get_widget(xml,"display_flat");
  gtk_object_set_data(GTK_OBJECT(w),"mgr",mgr);

  w = glade_xml_get_widget(xml,"display_smooth");
  gtk_object_set_data(GTK_OBJECT(w),"mgr",mgr);

  w = glade_xml_get_widget(xml,"glarea");
  gtk_object_set_data(GTK_OBJECT(w),"mgr",mgr);

}

int main(int argc, char **argv)
{
	GladeXML*	xml = NULL;
	Mgr*		mgr = NULL;

  parseCmdLine(argc,argv);

  // start gtk, handle command-line parameters
  gtk_init(&argc, &argv);

  // check if OpenGL and GLX are supported
  if(!gdk_gl_query()) g_error("OpenGL not supported\n");

  // start libglade
  glade_init();

  // create glade interface and make sure the interface was found
  if(!(xml = glade_xml_new("main.glade",(char *)NULL)))
    g_error("Error creating libglade interface");

  // connect widgets to signals
  glade_xml_signal_autoconnect(xml);

  // create object manager to contain POR data, Image objects and interface
  // with GUI
  if(!(mgr = new Mgr()))
    g_error("Could not create object manager\n");

  // attach data pointer to widgets
  set_widget_data(xml,mgr);

  // gtk main loop
  gtk_main();

  return(0);
}
