#ifndef MGR_H
#define MGR_H

#include        <iostream>
#include        <iomanip>
#include	<vector>
#include	<string>
#include	<list>
#include        <stdlib.h>
#include        <math.h>

#include        <glib.h>
#include	<gtk/gtk.h>
#include        <gdk/gdk.h>
#include        <gdk/gdkkeysyms.h>
#include        <gtk/gtkwidget.h>
#include        <gtkgl/gtkglarea.h>
#include        <GL/gl.h>
#include        <GL/glu.h>

using namespace std;

#include	"callbacks.h"

// display type
#define DISP_WIRE        0x30
#define DISP_FLAT        0x32
#define DISP_SMTH        0x34

class Mgr {
	public:
	// constructors
	Mgr() : \
		displayType(DISP_WIRE) \
			{ };

	// destructors

	// friends
friend	ostream&                operator<<(ostream& s, Mgr& rhs);
friend	ostream&                operator<<(ostream& s, Mgr* rhs)
                                { return(s << (*rhs)); }

	// (friend) callbacks


friend	void
on_obj_open_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

friend	gint on_obj_ok_button_clicked(GtkWidget* widget, GtkWidget *w);

friend	void
on_obj_clear_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
friend	void
on_quit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
friend void
on_display_wire_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
friend void
on_display_flat_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
friend void
on_display_smooth_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
friend	void
on_glarea_realize                      (GtkWidget       *widget,
                                        gpointer         user_data);
friend	gboolean
on_glarea_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data);

friend	GtkWidget*
on_glarea_create (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2);

friend	gboolean
on_glarea_event_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

friend	gboolean
on_glarea_event_button_release_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

friend	gboolean
on_glarea_event_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data);
	protected:

	private:

 	// here we'd also want to store a list of graphics objects, e.g.,
	// vector<awObject *>		obj;
	// once the awobject class is defined (aw = Alias|Wavefront)

	// display
	int		displayType;	// DISP_WIRE | DISP_FLAT | DISP_SMTH
};

#endif
